# algorithm to simulate from GvMF when Y=1

AR2 <- function(mu1, mu2, k1,k2) {
  
  source("sphere_m_unit.R")
  source("Wood_vMF_mu_Rodrigues.R")
  source("Rodrigues.R")
  n <- 1
  m <- 3 
  nu <- mu1/k2-mu2/k1
  norm <- sqrt(sum(nu^2))
  nu_norm <- nu/norm
  beta <- k1*k2*norm
  
  f <- function(x) exp(k1*sum(x*mu1)+k2*(sum(x*mu2)^2))
  g <- function(x) exp(beta*sum(x*nu_norm))
  
  
  N <- 1e3
  n_count <- 1
  Y <- matrix(NA, n,m)
  
  X_final <- matrix(NA,n,m)
  start.time <- Sys.time()
  while (n_count < N) {
    for (i in 1:n) {
      Y[i,] <- Wood_vMF_mu_Rodrigues(m,nu_norm,beta)
      U <- runif(1,0,1)
      if (U <= f(Y[i,])/(g(Y[i,]))){
        n_count <- n_count + 1
        X_final[i,] <- Y[i,]
      }
    }  
  }
  return(X_final)
}