# MH algorithm to simulate GvMF with jumping vMF(mu1,k1)

MH_GVMF_K1 <- function(N_s,mu1,mu2,k1,k2){

source("Wood_vMF_mu_Rodrigues.R")
source("sphere_m_unit.R")
# -------------------- #
# -------------------- #

f <- function(x) exp(k1*sum(x*mu1)+k2*(sum(x*mu2)^2))
A <-  (k1/2)^(m/2-1)*(1/(gamma(m/2)*besselI(k1,m/2-1))) # normalizing constant of vMF
g <- function(x) 1/A*exp(k1*sum(x*mu1)) # density of vMF(mu1,k1)

# -------------------- #
psi <-  matrix(rep(mu1,N_s), nrow = m, ncol = N_s) # chain, starting point is mu1
psi <- t(psi) 

# -------------------- #

for (i in 2:N_s) {
  Y <- Wood_vMF_mu_Rodrigues(m,mu1,k1)
  acc_prob <- min((f(Y)/f(psi[i-1,]))*(g(psi[i-1,])/g(Y)),1)
  if (runif(1) < acc_prob) {psi[i,] <- Y} else {psi[i,]<- psi[i-1,]}
}

return(psi)

}

# ------------------ #