# calculation of probability of Y=1

PROB_Y <- function(mu1,mu2,k1,k2){
m <- 3
n_it <- 1e2
#A <- k1^(m/2-1)/((2*pi)^(m/2)*besselI(k1,m/2-1)) # vMF(mu1,k1) 
A <- (k1/2)^(m/2-1)*(1/(gamma(m/2)*besselI(k1,m/2-1)))   # normalizing constant vMF(mu1,k1) wrt uniform

h <- function(x) exp(k2*(sum(mu2*x))^2)

X <- matrix(NA, nrow=n_it, ncol = m)
for (i in 1:n_it) {
  X[i,] <- Wood_vMF_mu_Rodrigues(m,mu1,k1)
}

Y1 <- rep(0,n_it)

for (i in 1:n_it) {
  Y1[i] <- h(X[i,])
}


B <- A*mean(Y1) # constant of the GvMF, approximation

X <- matrix(NA, n_it,m)
for (i in 1:n_it) {
  X[i,] <- Wood_vMF_mu_Rodrigues(m,mu1,k1) # vMF(mu1,k1)
}

I <- rep(0,n_it)

for (i in 1:n_it) {
  if (sum(X[i,]*mu2)>=0) {I[i] <- 1}
  else {I[i] <- 0}
}

P <- A/B*mean(I*Y1) # probability Y=1
return(P)
}

