# function that returns the rotation of a vector X using the Rogrigues matrix that
# rotates e_3 to a general vector m

Rodrigues <- function(m,X){
  if (m[1]==0 & m[2]==0 & m[3]==-1){
    
    return(c(X[1],X[2],-X[3]))
  } else if (m[1]==0 & m[2]==0 & m[3]==1) {
    
     return(X)} else {
       
  e3 <- c(0,0,1)
  
  m_x <- m[1]
  m_y <- m[2]
  m_z <- m[3]
  
  e3_x <- e3[1]
  e3_y <- e3[2]
  e3_z <- e3[3]
  
  v <- c(e3_y*m_z-e3_z*m_y, e3_z*m_x-e3_x*m_z, e3_x*m_y-e3_y*m_x)
  s <- (sum(v^2))^(1/2)
  
  c <- sum(e3*m)
  
  v_cross <- cbind(c(0,v[3],-v[2]),c(-v[3],0,v[1]),c(v[2],-v[1],0))
  
  R <- diag(3)+v_cross+v_cross%*%v_cross*((1-c)/s^2)
  
  return(R%*%X)
  }
  
}