# acceptance-rejection method to simulate an m=3-dimensional vector with distribution
# von Mises Fisher(mu, kappa). Using Rodrigues' rotation matrix.

Wood_vMF_mu_Rodrigues <- function(m,mu,kappa){
  source("Rodrigues.R")
  N <- 1e2
  n_count <- 0
  b <- (-2*kappa+(4*kappa^2+(m-1)^2)^(1/2))/(m-1)
  x0 <- (1-b)/(1+b)
  c <- kappa*x0 + (m-1)*log(1-x0^2)
  V <- rep(0,m - 1)
  X <- rep(0,m)
  while (n_count < N) {
    Z <- rbeta(1,(m - 1)/2,(m - 1)/2)
    U <- runif(1,0,1)
    W <- (1 - (1+b)*Z)/(1 - (1-b)*Z)
    if (kappa*W + (m-1)*log(1 - x0*W) - c >= log(U)) {
      n_count <- n_count + 1
      V <- sphere_m_unit(1, m - 1)
      X <- c(sqrt(1 - W^2)*V, W)
    }
  }
  
  Y <- Rodrigues(mu,X)
  
  return(Y)
  
}